//----------------------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//----------------------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  DarkOrange
#property indicator_color3  LimeGreen
#property indicator_color4  DarkOrange
#property indicator_width3  2
#property indicator_width4  2

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double SmoothPeriod1   = 6;
extern double SmoothPeriod2   = 30;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsPushNotif = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;
double bufferHc1[];
double bufferHo1[];
double bufferHh1[];
double bufferHl1[];
double bufferHc2[];
double bufferHo2[];
double trend1[];
double trend2[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,bufferHh1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferHl1); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferHc1); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,bufferHo1); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,bufferHc2);
   SetIndexBuffer(5,bufferHo2);
   SetIndexBuffer(6,trend1);
   SetIndexBuffer(7,trend2);
         
         //
         //
         //
         //
         //
         
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame == "returnBars";     if (returnBars)     { return(0); }
         calculateValue    = TimeFrame == "calculateValue"; if (calculateValue) { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
         
         //
         //
         //
         //
         //
         
   return(0);
}
int deinit()
{
   return(0);
}

//----------------------------------------------------------------------------------
//
//----------------------------------------------------------------------------------
//
//
//
//
//

double working[][6];
#define _haOpen  0
#define _haClose 1
#define _haHigh  2
#define _haLow   3
#define _haHigh2 4
#define _haLow2  5

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      int i,r,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         if (ArrayRange(working,0) != Bars) ArrayResize(working,Bars);
         if (returnBars) { bufferHh1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(i=limit, r=Bars-i-1; i >= 0; i--,r++)
      {
         working[r][_haOpen]  = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_OPEN ,i),SmoothPeriod1,i,0);
         working[r][_haClose] = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i),SmoothPeriod1,i,1);
         working[r][_haHigh]  = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH ,i),SmoothPeriod1,i,2);
         working[r][_haLow]   = iSsm(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW  ,i),SmoothPeriod1,i,3);
      
         //
         //
         //
         //
         //
      
         double haOpen  = (bufferHo2[i+1]+bufferHc2[i+1])/2.0; 
         double haClose = (working[r][_haOpen]+working[r][_haClose]+working[r][_haHigh]+working[r][_haLow])/4.0;
         double haHigh  = MathMax(working[r][_haHigh],MathMax(haOpen,haClose));
         double haLow   = MathMin(working[r][_haLow] ,MathMin(haOpen,haClose));

         if (haOpen<haClose) 
         {
            working[r][_haLow2]  = haLow;
            working[r][_haHigh2] = haHigh;
         } 
         else
         {
            working[r][_haHigh2] = haLow;
            working[r][_haLow2]  = haHigh;
         }
         bufferHo2[i]=haOpen;
         bufferHc2[i]=haClose;
         bufferHo1[i]=iSsm(bufferHo2[i]        ,SmoothPeriod2,i,4);
         bufferHc1[i]=iSsm(bufferHc2[i]        ,SmoothPeriod2,i,5);
         bufferHh1[i]=iSsm(working[r][_haHigh2],SmoothPeriod2,i,6);
         bufferHl1[i]=iSsm(working[r][_haLow2] ,SmoothPeriod2,i,7);
         trend1[i] = trend1[i+1];
         trend2[i] = trend2[i+1];
            if (bufferHh1[i]>bufferHl1[i]) trend1[i] =  1;
            if (bufferHh1[i]<bufferHl1[i]) trend1[i] = -1;
            if (bufferHc1[i]>bufferHo1[i]) trend2[i] =  1;
            if (bufferHc1[i]<bufferHo1[i]) trend2[i] = -1;
      }
      manageAlerts();
      return(0);
   }      
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         bufferHh1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod1,SmoothPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,0,y);
         bufferHl1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod1,SmoothPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,1,y);
         bufferHc1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod1,SmoothPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,2,y);
         bufferHo1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SmoothPeriod1,SmoothPeriod2,alertsOn,alertsOnCurrent,alertsMessage,alertsPushNotif,alertsSound,alertsEmail,3,y);

         //
         //
         //
         //
         //
      
         if (Interpolate<1 || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
          datetime time = iTime(NULL,timeFrame,y);
             for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
             for(int x = 1; x < n; x++)
             {
                bufferHl1[i+x] = bufferHl1[i] + (bufferHl1[i+n] - bufferHl1[i]) * x/n;
                bufferHh1[i+x] = bufferHh1[i] + (bufferHh1[i+n] - bufferHh1[i]) * x/n;
                bufferHc1[i+x] = bufferHc1[i] + (bufferHc1[i+n] - bufferHc1[i]) * x/n;
                bufferHo1[i+x] = bufferHo1[i] + (bufferHo1[i+n] - bufferHo1[i]) * x/n;
             }                
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][16];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
      if (trend1[whichBar] != trend1[whichBar+1])
      {
         if (trend1[whichBar] ==  1) doAlert(alertType1,alertTime1,"wick trend changed to up");
         if (trend1[whichBar] == -1) doAlert(alertType1,alertTime1,"wick trend changed to down");
      }
      static string   alertType2 = "";
      static datetime alertTime2 = 0;
      if (trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend2[whichBar] ==  1) doAlert(alertType2,alertTime2,"body trend changed to up");
         if (trend2[whichBar] == -1) doAlert(alertType2,alertTime2,"body trend changed to down");
      }
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  timeFrameToString(Period())+" "+StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," HA super smoother ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol(),"HA super smoother"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol(),"HA super smoother"+" "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}